/*
 * statefile.h		Statefile
 *
 * Copyright (c) 2001-2005 Thomas Graf <tgraf@suug.ch>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#ifndef __BMON_STATEFILE_H_
#define __BMON_STATEFILE_H_

#include <bmon/bmon.h>
#include <bmon/conf.h>

struct sf_token
{
	char		st_name[IFNAME_MAX];
	char		st_parent[IFNAME_MAX];
	uint32_t	st_handle;
	uint32_t	st_parent_handle;
	uint16_t	st_attr_type;
	rate_cnt_t	st_rx_rate;
	rate_cnt_t	st_tx_rate;
	b_cnt_t		st_rx_sum;
	b_cnt_t		st_tx_sum;
	b_cnt_t		st_rx_last;
	b_cnt_t		st_tx_last;
	timestamp_t	st_ts;
};

extern void write_statefile(const char *, int);

extern int open_statefile(const char *, int, FILE **);
extern struct sf_token *read_next_token(FILE *);
extern void close_statefile(int lock, FILE *);

extern int restore_from_statefile(const char *, int);

#endif
