/*
 * bmon/unit.h		Units
 *
 * Copyright (c) 2001-2005 Thomas Graf <tgraf@suug.ch>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#ifndef __BMON_UNIT_H_
#define __BMON_UNIT_H_

#include <bmon/bmon.h>

#define MAX_DIVISOR 8


struct unit {
	int		u_id;
	char *		u_name;
	b_cnt_t		u_divisors[MAX_DIVISOR];
	b_cnt_t		u_si_divisors[MAX_DIVISOR];
	char *		u_units[MAX_DIVISOR];
	char *		u_si_units[MAX_DIVISOR];
	int		u_have_si;
	int		u_idx;
	int		u_si_idx;

	struct unit *	u_next;
};

extern struct unit *lookup_unit(const char *);
extern double cancel_down(b_cnt_t, struct unit *, char **, int *);
extern b_cnt_t get_divisor(b_cnt_t, struct unit *, char **, int *);

extern void add_unit(const char *name, const char *def);

#endif
